#
#include	<stdint.h>
#include	<stdio.h>
#include	"mapper.h"
/*
 *
 * 	Simple mapper/demapper for dab modes I .. IV
 */

int16_t	*createMapper (int16_t T_u,
	               int16_t Range, int16_t V1, 
	               int16_t lwb, int16_t upb, int16_t *v) {
int16_t	*tmp	= (int16_t *)alloca (T_u * sizeof (int16_t));
int16_t	index	= 0;
int16_t	i;

	tmp [0]	= 0;
	for (i = 1; i < T_u; i ++)
	   tmp [i] = (13 * tmp [i - 1] + V1) % T_u;
	for (i = 0; i < T_u; i ++) {
	   if (tmp [i] == T_u / 2)
	      continue;
	   if ((tmp [i] < lwb) ||
	       (tmp [i] > upb)) 
	      continue;
//	we now have a table with values from lwb .. upb
//
	   v [index ++] = tmp [i] - T_u / 2;
//	we now have a table with values from lwb - T_u / 2 .. lwb + T_u / 2
	}

	return v;
}

	permVector::permVector (DabParams *p) {
//int16_t	i;
//int16_t	index	= 0;
//int16_t	*tmp	= (int16_t *)alloca (p -> T_u * sizeof (int16_t));
//	
//	permTable	= new int16_t [p -> K];
//	index = 0;
////	step 1: generate the permutation
//	   tmp [0] = 0;
//	   for (i = 1; i < p -> T_u; i ++) 
//	      tmp [i] = (13 * tmp [i - 1] + 511) % (p -> T_u);
////	step 2: make it into a map of p -> K elements
//
//	for (i = 0; i < p -> T_u; i ++) {
//	   if (tmp [i] == p -> T_u / 2)
//	      continue;
//	   if ((tmp [i] < 256) ||
//	       (tmp [i] > 1792)) 
//	      continue;
////	we now have a table with values from 256 .. 1792
////
//	   permTable [index ++] = tmp [i] - p -> T_u / 2;
////	we now have a table with values from -768 .. 768
//	}
	switch (p -> dabMode) {
	   case 1:
	   default:		// shouldn't happen
	      permTable	= createMapper (p -> T_u,
	                                p -> K, 511, 256, 256 + p -> K,
	                                new int16_t [p -> K]);
	      break;
	   case 2:
	      permTable = createMapper (p -> T_u,
	                                p -> K, 127, 64, 64 + p -> K,
	                                new int16_t [p -> T_u]);
	      break;

	   case 3:
	      permTable = createMapper (p -> T_u,
	                                p -> K, 63, 32, 32 + p -> K,
	                                new int16_t [p -> T_u]);
	      break;

	   case 4:
	      permTable = createMapper (p -> T_u,
	                                p -> K, 255, 128, 128 + p -> K,
	                                new int16_t [p -> T_u]);
	      break;
	}
}
//
//
	permVector::~permVector (void) {
	delete	permTable;
}
//
//	according to the standard, the map is a function from
//	0 .. 1535 -> -768 .. 768 (with exclusion of {0})
int16_t	permVector::mapIn (int16_t n) {
	return permTable [n];
}



