#ifndef	SPECTROGRAM
#define	SPECTROGRAM

#ifdef	__MINGW32__
#
//	for version qwt 5 we have
#include	<stdio.h>
#include	<stdlib.h>

class	SpectrogramData: public QwtRasterData {
public:
	double	*data;		// pointer to actual data
	int	left;		// index of left most element in raster
	int	width;		// raster width
	int	height;		// rasterheigth
	int	datawidth;	// width of matrix
	int	dataheight;	// for now == rasterheigth
	double	max;

	SpectrogramData (double *data, int left, int width, int height,
	                 int datawidth, double max):
        QwtRasterData (QwtDoubleRect((double)left, 0.0,
	                                     (double)width - 1, height - 1)) {
	this	-> left		= left;
	this	-> width	= width;
	this	-> data		= data;
	this	-> max		= max;
	this	-> height	= height;
	this	-> datawidth	= datawidth;
	this	-> dataheight	= height;
}

	~SpectrogramData () {
}

double value (double x, double y) const {
	   x = x - left;
	   x = x / width * datawidth;
	   return data [(int)y * datawidth + (int)x];
}

virtual QwtRasterData *copy() const {
        return new SpectrogramData (data, left, width, height, datawidth, max);
}

virtual QwtDoubleInterval range() const {
        return QwtDoubleInterval (0.0, max);
}

};


#else
#include	"jff-include.h"
#include	<stdio.h>
#include	<stdlib.h>
#include	<qwt_double_range.h>
#include	<qwt_interval.h>
#include	<qwt_raster_data.h>

class	SpectrogramData: public QwtRasterData {
public:
	double	*data;		// pointer to actual data
	int	left;		// index of left most element in raster
	int	width;		// raster width
	int	height;		// rasterheigth
	int	datawidth;	// width of matrix
	int	dataheight;	// for now == rasterheigth
	double	max;

	SpectrogramData (double *data, int left, int width, int height,
	                 int datawidth, double max):
        QwtRasterData () {
	this	-> data		= data;
	this	-> left		= left;
	this	-> width	= width;
	this	-> max		= max;
	this	-> height	= height;
	this	-> datawidth	= datawidth;
	this	-> dataheight	= height;

	setInterval (Qt::XAxis, QwtInterval (left, left + width));
	setInterval (Qt::YAxis, QwtInterval (0, height));
	setInterval (Qt::ZAxis, QwtInterval (0, max));
}

void	initRaster (const QRectF &x, const QSize &raster) {
	(void)x;
	(void)raster;
}

QwtInterval Interval (Qt::Axis x)const {
	if (x == Qt::XAxis)
	   return QwtInterval (left, left + width);
	return QwtInterval (0, max);
}

	~SpectrogramData () {
}

double value (double x, double y) const {
//fprintf (stderr, "x = %f, y = %f\n", x, y);
	   x = x - left;
	   x = x / width * datawidth;
	   return data [(int)y * datawidth + (int)x];
}

};

#endif
#endif

